<?php   
	 
/*
 * Functions for showing your images (or imageset) with teh use of Highslide.
 * Within your Concrete 5 website with the use of Highslide http//:highslide.com
 * @author Wim Bouter <wim@dewebmakers.nl>
 */
	 
defined('C5_EXECUTE') or die(_("Access Denied."));

Loader::model('file_version');

if (strlen($controller->dimmingopacity) == 1)
	$dimmingopacity = '0'.$controller->dimmingopacity;
	
$f = $t = Loader::helper('file');

foreach($controller->images as $imgInfo)  
{		
	$captions = '';
	$caption = '';
	$cap = '';
	
	$f = $t = File::getByID($imgInfo['fID']);
	$fp = $tp = new Permissions($f);
	
	$fv = $tv = $f->getApprovedVersion();	
		
	$image_size = $thumb_size = @getimagesize($f->getPath());
	
	if (intval($controller->thumb_attribute) == 1)
	{
		$attrib = FileAttributeKey::getByHandle('thumbnail');
		if (is_object($attrib)) 
		{	
			$vo = $f->getAttributeValueObject($attrib);		
			if (is_object($vo)) 
			{
				$file = $vo->getValue($attrib->akHandle);
				$t = File::getByID($file->fID);
				$tp = new Permissions($t);
				
				$tv = $t->getApprovedVersion();	
					
				$thumb_size = @getimagesize($t->getPath());
			}
		}
	}	
			
	if ($thumb_size[0] > $controller->thumb_width) {		
		$mw = $controller->thumb_width > 0 ? $controller->thumb_width : $thumb_size[0];
		
		if ($controller->thumb_width_crop != 0)
			$mh = $controller->thumb_width;
		else
			$mh = round(($thumb_size[1] / $thumb_size[0]) * $mw);
		
		$ih = Loader::helper('imageresizerHS', 'highslide_web_albums');
		$thumb = $ih->getThumbnailHS($t, $mw, $mh, $controller->thumb_width_crop);
		$sizeStr = ' width="' . $thumb_width . '" height="' . $mh . '"';
		$relPathThumb = $thumb->src;
	} else {
		$sizeStr = $thumb_size[3];
		$relPathThumb = $t->getRelativePath();
	}
		
	if ($image_size[0] > $controller->max_width) {		
		$mw = $controller->max_width > 0 ? $controller->max_width : $image_size[0];
		
		if ($controller->max_width_crop != 0)
			$mh = $max_width;
		else
			$mh = round(($image_size[1] / $image_size[0]) * $mw);
			
		$ih = Loader::helper('imageresizerHS', 'highslide_web_albums');
		$thumb = $ih->getThumbnailHS($f, $mw, $mh, $controller->max_width_crop);
		$relPathMax = $thumb->src;
	} else {
		$relPathMax = $f->getRelativePath();
	}
			
	echo('<a href="'.$relPathMax.'" onclick="return hs.expand(this)" class="highslide"><img src="'.$relPathThumb.'" '.$sizeStr.$alt.' /></a>'."\n");
	
	if ($controller->alttags && sizeof($controller->selected_attributes) > 0) {
		if ($controller->alttags_title) 
			$size = '_small';
		else
			$size = '_large';
								
		foreach ($controller->selected_attributes as $sa) {	
			$attrib = FileAttributeKey::getByHandle($sa);
			if (is_object($attrib)) {	
				$vo = $f->getAttributeValueObject($attrib);		
				if (is_object($vo)) {
					$captions[] = array('title' => $attrib->akName,
									    'value' => $vo->getValue($attrib->akHandle));
				}
			}
			elseif ($sa == 'fvFileID' && trim($fv->getFileID()) != '') 
				$captions[] = array('title' => substr($sa, 2),
									'value' => $fv->getFileID());
			elseif ($sa == 'fvFilename' && trim($fv->getFileName()) != '') 
				$captions[] = array('title' => substr($sa, 2),
									'value' => $fv->getFileName());	
			elseif ($sa == 'fvSize' && trim($fv->getSize()) != '') 
				$captions[] = array('title' => substr($sa, 2),
									'value' => $fv->getSize());									
			elseif ($sa == 'fvDateAdded' && trim($fv->getDateAdded()) != '') 
				$captions[] = array('title' => 'Date Added',
									'value' => $fv->getDateAdded());
			elseif ($sa == 'fvTitle' && trim($fv->getTitle()) != '') 
				$captions[] = array('title' => substr($sa, 2),
									'value' => $fv->getTitle());
			elseif ($sa == 'fvDescription' && trim($fv->getDescription()) != '') 
				$captions[] = array('title' => substr($sa, 2),
									'value' => $fv->getDescription());
			elseif ($sa == 'fvTags' && trim($fv->getTags()) != '') 
				$captions[] = array('title' => substr($sa, 2),
									'value' => $fv->getTags());
			elseif ($sa == 'fvAuthor' && trim($fv->getAuthorName()) != '') 
				$captions[] = array('title' => substr($sa, 2),
									'value' => $fv->getAuthorName());
			elseif ($sa == 'fvDownload') 
				$captions[] = array('title' => substr($sa, 2),
									'value' => '<a href="'.$fv->getDownloadURL().'">Download File</a>');
		}

		if (is_array($captions) && sizeof($captions) > 0)
		{
			foreach($captions as $cap)
			{
				$caption .= '<div class="hs_row">'."\n";
				if ($controller->alttags_title) 
					$caption .= '<div class="hs_row_title">'.$cap['title'].'</div>'."\n";
	
				$caption .= '<div class="hs_row_content'.$size.'">'.$cap['value'].'</div>'."\n";				
				$caption .= '</div>'."\n";
			}	
			echo ('<div class="highslide-caption">'.$caption.'</div>'."\n\n");
		}	
	}
}